---
title: POS 2
layout: layouts/base_subject.njk
eleventyNavigation:
  key: POS 2
  parent: POS
  order: 2
---

<p>We will switch groups after eight weeks of education. That is, the first
  day after the switch is May 2nd. Group 1 starts with Prof. ZI, group 2
  starts with SG.
</p>

<h2 id="overview">Course Overview</h2>
<ul>
  <li><a href="/presentations/c/introduction/">Programming in C - Introduction</a></li>
  <li><a href="/presentations/c/fast_track/">Fast Track to C Syntax for Programmers</a></li>
  <li><a href="/presentations/c/arrays/">Programming in C - Arrays</a></li>
  <li><a href="/presentations/c/strings/">Programming in C - Working with Text</a></li>
  <li><a href="/presentations/c/structs/">Programming in C - Typedef and Structs - Composite Data Types</a></li>
  <li><a href="/presentations/c/multiple_files/">Programming in C - Working with multiple source files and build tools</a></li>
  <li><a href="/presentations/c/pointers/">Programming in C - Pointers</a></li>
  <li><a href="/presentations/c/dynamic_memory_management/">Programming in C - Dynamic Memory Management</a></li>
  <li><a href="/presentations/c/unit_testing/">Unit Testing</a></li>
  <li><a href="https://www.senarclens.eu/~gerald/presentations/cms1/old_11_cpp/">Introduction to Basic C++ for Programmers — Part 1</a></li>
  <li><a href="https://www.senarclens.eu/~gerald/presentations/dvc/">Git Introduction</a>
    (reference <a href="http://docs.find-santa.eu/dvcs/">material for learning
     git</a>)</li>
  <li><a href="https://www.senarclens.eu/~gerald/presentations/cms1/7_basic_classes/">Intro to Object Orientation (with Python)</a></li>
  {# <li><a href="https://www.senarclens.eu/~gerald/presentations/cms1/old_12_cpp/">Introduction to Basic C++ for Programmers — Part 2</a></li> #}

    {#
  <li>Collection Data Types in C++ (std template library)
  </li>
  <li>Running Micropython / C on a Microcontroller</li> #}
</ul>

<h2 id="exercises">Programming Exercises</h2>
<ul>
  <li><a href="/exercises/c/exercise_1/">C exercise 1</a></li>
  <li><a href="/exercises/c/exercise_3/">C exercise 3</a></li>
  <li><a href="/exercises/c/exercise_strings/">C strings</a></li>
  <li><a href="/exercises/c/exercise_structs/">Structs</a></li>
  <li><a href="/exercises/c/exercise_multiple_files/">Multiple source files</a></li>
  <li><a href="/exercises/c/exercise_pointers/">Pointers</a></li>
  <li><a href="/exercises/c/exercise_free_store/">
    Dynamic memory management (free store)</a></li>
  <li><a href="/exercises/cpp/exercise_1/">C++ exercise 1</a></li>
</ul>

<h2 id="exams">Prior Exams</h2>
<ul>
  <li><a href="tests/pos2_midterm_s2022_a_de/">POS 2 mid term s2022 (group A)</a></li>
  <li><a href="tests/pos2_final_s2022_a_de/">POS 2 final term s2022 (group A)</a></li>
</ul>

<h2 id="links">Links</h2>

<h3 id="source">Source Code Examples</h3>
<ul>
  <li><a href="/data/py/data_analysis.ipynb">data_analysis.ipynb</a></li>
</ul>

<h3 id="software">Software</h3>
<ul>
  <li>KDE Neon Linux-based VirtualBox image with all programming tools we need:
    <a href="https://lehrer.bulme.at/~sg/vms/progamming.ova">progamming.ova</a><br />
    Download with username: <kbd>student</kbd>, ask in class for the password<br />
    Login with username: <kbd>student</kbd>, password: <kbd>changeme</kbd></li>
  <li><a href="https://www.virtualbox.org/wiki/Downloads">VirtualBox</a></li>
  <li><a href="https://files.kde.org/neon/images/user/current/neon-user-current.iso">KDE Neon Linux ISO image</a></li>
  <li>Text editor: <a href="https://vscodium.com/">VSCodium</a> or
    <a href="https://code.visualstudio.com/">Visual Studio Code</a></li>
  <li><a href="http://www.cplusplus.com/doc/tutorial/">C++ Language Tutorial</a></li>
  <li><a href="https://google.github.io/styleguide/cppguide.html">Google C++ Style Guide</a></li>
</ul>

{% include 'blocks/code_challenge_sites.njk' %}

{# <h3 id="books">Programming Books</h3>
<ul>
  <li>Python for Data Analysis: Data Wrangling with Pandas, NumPy, and IPython
    (<a href="http://www.amazon.de/gp/product/1449319793/ref=as_li_tl?ie=UTF8&amp;camp=1638&amp;creative=19454&amp;creativeASIN=1449319793&amp;linkCode=as2&amp;tag=findsantaeu-21&amp;linkId=DP3XJON365UK7X2C">buy on Amazon</a>)
  </li>
</ul> #}


<h2 id="lehrstoff">Lehrstoff</h2>

<ul>
  <li>Bereich Programmiergrundlagen
    <ul>
      <li>Geeignete Datenstrukturen für verschiedene Problemstellungen auswählen und implementieren</li>
      <li>Die Grundlagen der objektorientierten Programmierung erklären</li>
    </ul>
  </li>
  <li>Bereich Anwendungsprogrammierung
    <ul>
      <li>API-Dokumentationen lesen, verstehen und für ihre eigenen Programme
        Dokumentationen erstellen
      </li>
      <li>Externe Programmbausteine in eigene Programme integrieren und eigene
        Programmbausteine zur Verfügung stellen</li>
    </ul>
  </li>
  <li>Bereich Softwareentwicklungsprozess
    <ul>
      <li>Mit gängigen Werkzeugen zur Unterstützung der Softwareentwicklung effektiv umgehen</li>
      <li>Eine gegebene Problemstellung analysieren und mit Hilfe von grafischen Notationen darstellen</li>
      <li>Einfache Testfälle definieren und damit Programme systematisch testen</li>
    </ul>
  </li>
</ul>
